image:
  name: amazon/aws-cli:latest
  entrypoint:
    - "/usr/bin/env"

.stage:
  stage: stage
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  before_script:
    - >
      STS=($(aws sts assume-role-with-web-identity
      --role-arn ${ROLE_ARN}
      --role-session-name "${ROLE_SESSION_NAME}"
      --web-identity-token $CI_JOB_JWT_V2
      --duration-seconds 3600
      --query 'Credentials.[AccessKeyId,SecretAccessKey,SessionToken]'
      --output text))
    - export AWS_ACCESS_KEY_ID="${STS[0]}"
    - export AWS_SECRET_ACCESS_KEY="${STS[1]}"
    - export AWS_SESSION_TOKEN="${STS[2]}"
  script:
    - |
      TEMPLATE_URL=https://${BUCKET}.s3.${BUCKET_REGION}.amazonaws.com/${DEPLOY_PATH}
      USE_PARAMS=$( [[ -z "${PARAMS}" ]] && echo "" || echo "--parameters file://params/${PARAMS}.json" )

      echo '--- Checking if Stack Exists ---'

      if aws cloudformation describe-stacks --stack-name ${STACK_NAME} --region ${CLI_REGION} &>/dev/null ; then

        echo '--- Existing Stack Present ---'

        aws cloudformation delete-change-set \
          --stack-name ${STACK_NAME} \
          --change-set-name ${STACK_NAME}-changeset \
          --region ${CLI_REGION}

        aws cloudformation create-change-set \
          --stack-name ${STACK_NAME} \
          --change-set-name ${STACK_NAME}-changeset \
          --change-set-type UPDATE \
          --capabilities "CAPABILITY_IAM" "CAPABILITY_NAMED_IAM" \
          --template-url $TEMPLATE_URL \
          --region ${CLI_REGION} \
          ${USE_PARAMS}

      else

        echo '--- No Existing Stack ---'

        aws cloudformation create-change-set \
          --stack-name ${STACK_NAME} \
          --change-set-name ${STACK_NAME}-changeset \
          --change-set-type CREATE \
          --capabilities "CAPABILITY_IAM" "CAPABILITY_NAMED_IAM" \
           --template-url $TEMPLATE_URL \
          --region ${CLI_REGION} \
          ${USE_PARAMS}
      fi
